
package com.star.admin;

import java.rmi.*;

/**
 * Service endpoint interface for InsurancePlanAdmin web service 
 * hosted by Star Enterprise to be used by remote plan administrators.
 */
public interface InsurancePlanAdmin extends Remote {

    void createInsurancePlan(String planId, String planName, int planType,
                             double coverageFactor, double ageFactor,
                             double smokerCost) throws RemoteException;

    PlanInfo getPlanInfo(String planId) throws RemoteException;

    void addDoctors(String planId, DoctorInfo[] doctors) throws RemoteException;

    void removeDoctors(String planId, DoctorInfo[] doctors) throws RemoteException;

    DoctorInfo[] getAllDoctors(String planId) throws RemoteException;

    void setSmokerCost(String planId, double cost) throws RemoteException;

    void setCoverageFactor(String planId, double s) throws RemoteException;

    void setAgeFactor(String planId, double s) throws RemoteException;
}


