
package com.star.admin.client;

import javax.xml.rpc.Stub;
import javax.naming.*;

import com.star.admin.client.intfs.*;

/**
 * Standalone client used to populate health insurance plans in the
 * InsurancePlanAdmin web service.
 */
public class AdminClient {

    private String endpointAddress;

    public static void main(String[] args) {

        System.out.println("InsurancePlanAdmin webservice address " + args[0]);

        try {
            InsurancePlanAdminService adminService = 
				    new InsurancePlanAdminService_Impl();
            InsurancePlanAdmin adminPort = 
				    adminService.getInsurancePlanAdminPort();
            ((Stub)adminPort)._setProperty(Stub.ENDPOINT_ADDRESS_PROPERTY,
					   args[0]);

            adminPort.createInsurancePlan("MedicalPlan1", "United Healthcare 1",
					  1, 100.0, 10.0, 200.0);
            adminPort.createInsurancePlan("DentalPlan1", "Metlife Dental 1", 
					  2, 100.0, 10.0, 300.0);
            System.exit(0);

        } catch (Exception ex) {
            ex.printStackTrace();
            System.exit(1);
        }
    } 
} 

