
package com.star.payroll;

import javax.ejb.*;
import javax.rmi.PortableRemoteObject;
import javax.naming.InitialContext;

import com.wombat.benefits.DeductionUpdateBean;

import com.star.payroll.Payroll;
import com.star.payroll.PayrollHome;

/**
 * An implementation of the DeductionUpdateBean command bean interface
 * which was defined by Wombat. This implementation uses the PayrollEJB 
 * stateless session bean to store payroll deduction information 
 * in Star Enterprise's payroll database.
 */
public class DeductionUpdateBeanImpl implements DeductionUpdateBean {

    private Payroll payroll;
    private int emplNumber;
    private double deduction;

    public DeductionUpdateBeanImpl() {
	try {
	    InitialContext ictx = new InitialContext();
	    Object obj = ictx.lookup("java:comp/env/ejb/PayrollEJB");
	    PayrollHome payrollHome = (PayrollHome)
			    PortableRemoteObject.narrow(obj, PayrollHome.class);
	    payroll = payrollHome.create();
	} catch ( Exception ex ) {
	    throw new EJBException("Unable to get Payroll bean", ex);
	}
    }

    public void setBenefitsDeduction(int emplNumber, double deduction) {
	this.emplNumber = emplNumber; 
	this.deduction = deduction;
    }

    public void execute() {
	try {
	    payroll.setBenefitsDeduction(emplNumber, deduction);
	} catch (Exception ex) {
	    throw new EJBException(ex);
	}               

    }

    public void release() {
	try {
	    payroll.remove();
	} catch (Exception ex) {
	}
    }
}

