
package com.star.payroll;

import javax.ejb.*;
import javax.jms.*;
import javax.naming.InitialContext;

import com.star.payroll.PayrollLocal;
import com.star.payroll.PayrollLocalHome;

/**
 * Message driven bean class that receives messages from the PayrollQueue
 * and calls the PayrollEJB stateless session bean to update benefits
 * deductions.
 */
public class PayrollMDB implements MessageDrivenBean, MessageListener {

    private PayrollLocal payroll;

    public void setMessageDrivenContext(MessageDrivenContext mdc) {
	try {
	    InitialContext ictx = new InitialContext();
	    PayrollLocalHome payrollHome = (PayrollLocalHome)
				ictx.lookup("java:comp/env/ejb/PayrollEJB");
	    payroll = payrollHome.create();
	} catch ( Exception ex ) {
	    throw new EJBException("Unable to get Payroll bean", ex);
	}
    }

    public void ejbCreate() { }

    public void ejbRemove() { }

    public void onMessage(Message msg) {
	MapMessage map = (MapMessage)msg;

	try {
	    int emplNumber = map.getInt("Employee");
	    double deduction = map.getDouble("BenefitsDeduction");
	    
	    payroll.setBenefitsDeduction(emplNumber, deduction);
	} catch ( Exception ex ) {
	    throw new EJBException(ex);
	}
    }
}

