
package com.wombat.benefits;

/**
 * Exception class used for reporting errors in employee benefits selections.
 */
public class SelectionException extends Exception {
    // error codes
    public static int UNKNOWN = 0;
    public static int INVAL_PARAM = 1;
    public static int INVAL_COVERAGE = 2;
    public static int INVAL_PLAN_TYPE = 3;

    static String[] defaultMessage = {
        "unknown error code",
        "invalid value of input parameter",
        "invalid coverage value",
        "invalid plan type"
    };

    private int errorCode;

    public SelectionException() {
        super();
    }

    public SelectionException(String s) {
        super(s);
    }

    public SelectionException(int errorCode, String s) {
        super(s);
        this.errorCode = errorCode;
    }

    public SelectionException(int errorCode) {
        super(errorCode >= 0 && errorCode < defaultMessage.length ?
            defaultMessage[errorCode] : "");
        this.errorCode = errorCode;
    }
}
