<%@ page language="java" %>
<%@ page import="javax.naming.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.wombat.benefits.*" %>
<%@ page import="com.wombat.plan.*" %>

<html>
<body>

<%
	    String message = null;
	    try {
		// Create employee
		System.err.println("Starting initialization...");

		InitialContext ic = new InitialContext();

		// Populate plan database with Providence plans.
		// TODO: This should be done periodically using an EJB Timer 
		// to take care of any dynamic changes in Providence plans.
		PlanHome ph = (PlanHome)
				    ic.lookup("java:comp/env/ejb/Plan");
		PlanHome providence = (PlanHome)
				ic.lookup("java:comp/env/ejb/ProvidencePlan");

		Collection plans = providence.findMedicalPlans();
		System.err.println("Found "+plans.size()+" Providence medical plans.");
		Iterator i = plans.iterator();
		while ( i.hasNext() ) {
		    Plan p = (Plan)i.next();
		    ph.create(p.getPlanId(), p.getPlanName(), p.getPlanType(), 
			      p.getCoverageFactor(), p.getAgeFactor(), 
			      p.getSmokerCost());
		}

		plans = providence.findDentalPlans();
		System.err.println("Found "+plans.size()+" Providence dental plans.");
		i = plans.iterator();
		while ( i.hasNext() ) {
		    Plan p = (Plan)i.next();
		    ph.create(p.getPlanId(), p.getPlanName(), p.getPlanType(), 
			      p.getCoverageFactor(), p.getAgeFactor(), 
			      p.getSmokerCost());
		}

		System.err.println("Initialization completed successfully.");
		message = "Plan initialization completed successfully.";
	    } 
	    catch ( Exception ex ) {
		ex.printStackTrace();
		// end the session, logout the user
		try {
		    session.invalidate();
		} catch ( Exception e ) {}
		message = "Error in plan initialization: see server.log file.";
	    }

%>

<%= message %>

</body>
</html>
