
package com.wombat.plan;

import javax.ejb.*;

import java.util.Collection;

/**
 * Local interface for PlanEJB.
 */
public interface Plan extends EJBLocalObject {
    // values of planType CMP field
    public final int MEDICAL_PLAN = 1;
    public final int DENTAL_PLAN = 2;

    // values of coverage category
    public static final int EMPLOYEE_ONLY = 0;
    public static final int EMPLOYEE_SPOUSE = 1;
    public static final int EMPLOYEE_SPOUSE_CHILDREN = 2;

    // business methods
    int getPlanType();

    String getPlanId();

    String getPlanName();

    double getAgeFactor();
    void setAgeFactor(double a);

    double getCoverageFactor();
    void setCoverageFactor(double c);

    double getSmokerCost();
    void setSmokerCost(double cost);

    double getCost(int coverage, int age, boolean isSmoker)
        throws PlanException;

    void addDoctor(Doctor doctor) throws PlanException;
    boolean removeDoctor(Doctor doctor) throws PlanException;

    Collection getAllDoctors() throws PlanException;

    Collection getDoctorsByName(String fname, String lname) 
	throws PlanException;

    Collection getDoctorsBySpecialty(String specialty) 
	throws PlanException;
}
