package com.wombat.plan;

/**
 * Exception class for reporting errors in plan information.
 */
public class PlanException extends Exception {
    // error codes
    public static int UNKNOWN = 0;
    public static int INVAL_PARAM = 1;


    static String[] defaultMessage = {
        "unknown error code",
        "invalid value of input parameter"
    };

    private int errorCode;

    public PlanException() {
        super();
    }

    public PlanException(String s) {
        super(s);
    }

    public PlanException(int errorCode, String s) {
        super(s);
        this.errorCode = errorCode;
    }

    public PlanException(int errorCode) {
        super(errorCode >= 0 && errorCode < defaultMessage.length ?
            defaultMessage[errorCode] : "");
        this.errorCode = errorCode;
    }
}
