
package com.star.benefits.db;

import javax.ejb.*;
import java.sql.*;
import javax.sql.*;

public class DBInit {
    DataSource ds;

    public DBInit() { }

    public DBInit(DataSource ds) {
        this.ds = ds;
    }

    public void execute() {
        try {
            Connection con = ds.getConnection("", "");
            execute(con);
        } catch ( Exception ex ) {
            throw new EJBException(ex);
        }
    }

    public void execute(Connection con) {
        try {
            Statement stmt = con.createStatement();

            trace("creating tables");

            try {
                stmt.executeUpdate("drop table employees");
            } catch (Exception ex) {}
            try {
                stmt.executeUpdate("drop table positions");
            } catch (Exception ex) {}
            try {
                stmt.executeUpdate("drop table departments");
            } catch (Exception ex) {}
            try {
                stmt.executeUpdate("drop table selections");
            } catch (Exception ex) {}
            try {
                stmt.executeUpdate("drop table providers");
            } catch (Exception ex) {}
            try {
                stmt.executeUpdate("drop table plans");
            } catch (Exception ex) {}
            try {
                stmt.executeUpdate("drop table paychecks");
            } catch (Exception ex) {}

            // XXX add primary key to synch with book
            stmt.executeUpdate("create table employees ( " +
                "empl_id int, " +
                "empl_first_name  varchar(32), " +
                "empl_last_name   varchar(32), " +
                "empl_addr_street varchar(32), " +
                "empl_addr_city   varchar(32), " +
                "empl_addr_zip    varchar(10), " +
                "empl_addr_state  varchar(2), " +
                "empl_dept_id     varchar(10), " +
                "empl_start_date  date, " +
                "empl_position    varchar(5), " +
                "empl_birth_date  date" +
                ")" );

            stmt.executeUpdate("create table positions ( " +
                "pos_id   varchar(5), " +
                "pos_desc varchar(32) " +
                ")" );

            stmt.executeUpdate("create table departments ( " +
                "dept_id   varchar(10), " +
                "dept_desc varchar(32), " +
                "dept_mgr  int " +
                ")" );

            stmt.executeUpdate("create table providers ( " +
                "prov_id   varchar(10), " +
                "prov_name varchar(32) " +
                ")" );

            stmt.executeUpdate("create table selections ( " +
                "sel_empl         int, " +
                "sel_coverage     int, " +
                "sel_medical_plan varchar(10), " +
                "sel_dental_plan  varchar(10), " +
                "sel_smoker       char(1) " +
                ")" );
 
            trace("A");
            stmt.executeUpdate("create table paychecks ( " +
                "pay_empl         int, " +
                "pay_salary       float, " +
                "pay_ded_benefits float " +
                ")" );
            trace("B");

            trace("inserting records into tables");

            stmt.executeUpdate("insert into employees values " +
    "(100, 'Duke', 'Mascot', '4150 Network Circle', 'Santa Clara', " +
    "'95054', 'CA', 'EJBARCH', '1996-04-04', 'Eng', '1992-03-16' )" );

            trace("C");
            stmt.executeUpdate("insert into paychecks values " +
    "(100, 200000.00, 0.0)" );

            trace("D");

            
            con.close();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new EJBException(ex);
        }
    }

    void trace(String s) { 
        System.err.println("DAO: " + s); 
    }

}

