package com.star.benefits.db;

import java.sql.SQLException;
import javax.sql.DataSource;

public class DBQuerySelection extends DBQueryBean {
    static String statement = 
        "SELECT sel_coverage, sel_smoker, " +
            "sel_medical_plan,  sel_dental_plan " +
        "FROM Selections WHERE sel_empl = ?";

    public DBQuerySelection(DataSource ds) throws SQLException {
        super(ds, statement);
    }

    public void setEmployeeNumber(int emplNum) throws SQLException {
        pstmt.setInt(1, emplNum);
    }


    public int getCoverage() throws SQLException {
        return resultSet.getInt(1);
    }
    public boolean getSmokerStatus() throws SQLException {
        return resultSet.getString(2).equals("Y");
    }
    public String getMedicalPlanId() throws SQLException {
        return resultSet.getString(3);
    }
    public String getDentalPlanId() throws SQLException {
        return resultSet.getString(4);
    }
}
