
package com.star.payroll;

/**
 * An exception class used for reporting payroll system errors.
 */
public class PayrollException extends Exception {
    // error codes
    public static int UNKNOWN = 0;
    public static int INVAL_EMPL_NUMBER = 1;

    static String[] defaultMessage = {
        "unknown error code",
        "invalid employee number"
    };

    int errorCode;

    public PayrollException() { super(); }
    public PayrollException(String s) { super(s); }
    public PayrollException(int errorCode, String s) {
        super(s);
        this.errorCode = errorCode;
    }
    public PayrollException(int errorCode) {
        super(errorCode >= 0 && errorCode < defaultMessage.length ?
            defaultMessage[errorCode] : "");
        this.errorCode = errorCode;
    }
}
